#include "beremiz.h"
#ifndef __POUS_H
#define __POUS_H

#include "accessor.h"
#include "iec_std_lib.h"

__DECLARE_ENUMERATED_TYPE(LOGLEVEL,
  LOGLEVEL__CRITICAL,
  LOGLEVEL__WARNING,
  LOGLEVEL__INFO,
  LOGLEVEL__DEBUG
)
__DECLARE_STRUCT_TYPE(SCNV,
  BOOL LRUN;
    BOOL RRUN;
    BOOL LSLEFT;
    BOOL LSRIGHT;
  )
__DECLARE_STRUCT_TYPE(SMANU,
  BOOL RQCNVLEFT;
    BOOL RQCNVRIGHT;
  )
__DECLARE_STRUCT_TYPE(SIO,
  BOOL LS1;
    BOOL LS2;
    BOOL LS3;
    BOOL LS4;
    BOOL LS5;
    BOOL PB1;
    BOOL PB2;
    BOOL PB3;
    BOOL PB4;
    BOOL PB5;
    BOOL SS1;
    BOOL SS0;
    BOOL DSW1;
    BOOL DSW2;
    BOOL DSW4;
    BOOL DSW8;
    BOOL RY1;
    BOOL RY2;
    BOOL PL1;
    BOOL PL2;
    BOOL PL3;
    BOOL PL4;
    BOOL DP1;
    BOOL DP2;
    BOOL DP4;
    BOOL DP8;
    BOOL DP10;
    BOOL DP20;
    BOOL DP40;
    BOOL DP80;
    BOOL SPD0;
    BOOL SPD1;
  )
// FUNCTION_BLOCK LOGGER
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,TRIG)
  __DECLARE_VAR(STRING,MSG)
  __DECLARE_VAR(LOGLEVEL,LEVEL)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(BOOL,TRIG0)

} LOGGER;

void LOGGER_init__(LOGGER *data__, BOOL retain);
// Code part
void LOGGER_body__(LOGGER *data__);
// FUNCTION_BLOCK PYTHON_EVAL
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,TRIG)
  __DECLARE_VAR(STRING,CODE)
  __DECLARE_VAR(BOOL,ACK)
  __DECLARE_VAR(STRING,RESULT)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(DWORD,STATE)
  __DECLARE_VAR(STRING,BUFFER)
  __DECLARE_VAR(STRING,PREBUFFER)
  __DECLARE_VAR(BOOL,TRIGM1)
  __DECLARE_VAR(BOOL,TRIGGED)

} PYTHON_EVAL;

void PYTHON_EVAL_init__(PYTHON_EVAL *data__, BOOL retain);
// Code part
void PYTHON_EVAL_body__(PYTHON_EVAL *data__);
// FUNCTION_BLOCK PYTHON_POLL
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,TRIG)
  __DECLARE_VAR(STRING,CODE)
  __DECLARE_VAR(BOOL,ACK)
  __DECLARE_VAR(STRING,RESULT)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(DWORD,STATE)
  __DECLARE_VAR(STRING,BUFFER)
  __DECLARE_VAR(STRING,PREBUFFER)
  __DECLARE_VAR(BOOL,TRIGM1)
  __DECLARE_VAR(BOOL,TRIGGED)

} PYTHON_POLL;

void PYTHON_POLL_init__(PYTHON_POLL *data__, BOOL retain);
// Code part
void PYTHON_POLL_body__(PYTHON_POLL *data__);
// FUNCTION_BLOCK PYTHON_GEAR
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(UINT,N)
  __DECLARE_VAR(BOOL,TRIG)
  __DECLARE_VAR(STRING,CODE)
  __DECLARE_VAR(BOOL,ACK)
  __DECLARE_VAR(STRING,RESULT)

  // FB private variables - TEMP, private and located variables
  PYTHON_EVAL PY_EVAL;
  __DECLARE_VAR(UINT,COUNTER)
  __DECLARE_VAR(UINT,_TMP_ADD10_OUT)
  __DECLARE_VAR(BOOL,_TMP_EQ13_OUT)
  __DECLARE_VAR(UINT,_TMP_SEL15_OUT)
  __DECLARE_VAR(BOOL,_TMP_AND7_OUT)

} PYTHON_GEAR;

void PYTHON_GEAR_init__(PYTHON_GEAR *data__, BOOL retain);
// Code part
void PYTHON_GEAR_body__(PYTHON_GEAR *data__);
// PROGRAM INTERFACEOUT
// Data part
typedef struct {
  // PROGRAM Interface - IN, OUT, IN_OUT variables

  // PROGRAM private variables - TEMP, private and located variables
  __DECLARE_EXTERNAL(SIO,G_SIO)
  __DECLARE_VAR(BOOL,OUT_0)
  __DECLARE_VAR(BOOL,OUT_1)
  __DECLARE_VAR(BOOL,OUT_2)
  __DECLARE_VAR(BOOL,OUT_3)
  __DECLARE_VAR(BOOL,OUT_4)
  __DECLARE_VAR(BOOL,OUT_5)
  __DECLARE_VAR(BOOL,OUT_6)
  __DECLARE_VAR(BOOL,OUT_7)
  __DECLARE_VAR(BOOL,OUT_8)
  __DECLARE_VAR(BOOL,OUT_9)
  __DECLARE_VAR(BOOL,OUT_10)
  __DECLARE_VAR(BOOL,OUT_11)
  __DECLARE_VAR(BOOL,OUT_12)
  __DECLARE_VAR(BOOL,OUT_13)
  __DECLARE_VAR(BOOL,OUT_14)

} INTERFACEOUT;

void INTERFACEOUT_init__(INTERFACEOUT *data__, BOOL retain);
// Code part
void INTERFACEOUT_body__(INTERFACEOUT *data__);
// PROGRAM CONVEROBJ
// Data part
typedef struct {
  // PROGRAM Interface - IN, OUT, IN_OUT variables

  // PROGRAM private variables - TEMP, private and located variables
  __DECLARE_EXTERNAL(SCNV,G_SCNV)
  __DECLARE_EXTERNAL(SMANU,G_SMANU)
  __DECLARE_EXTERNAL(SIO,G_SIO)

} CONVEROBJ;

void CONVEROBJ_init__(CONVEROBJ *data__, BOOL retain);
// Code part
void CONVEROBJ_body__(CONVEROBJ *data__);
// PROGRAM LAMPOBJ
// Data part
typedef struct {
  // PROGRAM Interface - IN, OUT, IN_OUT variables

  // PROGRAM private variables - TEMP, private and located variables
  __DECLARE_EXTERNAL(SIO,G_SIO)
  __DECLARE_EXTERNAL(SCNV,G_SCNV)
  __DECLARE_VAR(BOOL,PLS1SEC)
  TON TON0;
  __DECLARE_VAR(BOOL,FF1SEC)
  __DECLARE_VAR(BOOL,FFRES)

} LAMPOBJ;

void LAMPOBJ_init__(LAMPOBJ *data__, BOOL retain);
// Code part
void LAMPOBJ_body__(LAMPOBJ *data__);
// PROGRAM INTERFACEIN
// Data part
typedef struct {
  // PROGRAM Interface - IN, OUT, IN_OUT variables

  // PROGRAM private variables - TEMP, private and located variables
  __DECLARE_EXTERNAL(SIO,G_SIO)
  __DECLARE_VAR(BOOL,IN_0)
  __DECLARE_VAR(BOOL,IN_1)
  __DECLARE_VAR(BOOL,IN_2)
  __DECLARE_VAR(BOOL,IN_3)
  __DECLARE_VAR(BOOL,IN_4)
  __DECLARE_VAR(BOOL,IN_5)
  __DECLARE_VAR(BOOL,IN_6)
  __DECLARE_VAR(BOOL,IN_7)
  __DECLARE_VAR(BOOL,IN_8)
  __DECLARE_VAR(BOOL,IN_9)
  __DECLARE_VAR(BOOL,IN_10)
  __DECLARE_VAR(BOOL,IN_11)
  __DECLARE_VAR(BOOL,IN_12)
  __DECLARE_VAR(BOOL,IN_13)
  __DECLARE_VAR(BOOL,IN_14)
  __DECLARE_VAR(BOOL,IN_15)

} INTERFACEIN;

void INTERFACEIN_init__(INTERFACEIN *data__, BOOL retain);
// Code part
void INTERFACEIN_body__(INTERFACEIN *data__);
// PROGRAM MANUCONT
// Data part
typedef struct {
  // PROGRAM Interface - IN, OUT, IN_OUT variables

  // PROGRAM private variables - TEMP, private and located variables
  __DECLARE_EXTERNAL(SMANU,G_SMANU)
  __DECLARE_EXTERNAL(SIO,G_SIO)

} MANUCONT;

void MANUCONT_init__(MANUCONT *data__, BOOL retain);
// Code part
void MANUCONT_body__(MANUCONT *data__);
#endif //__POUS_H
